<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_10</title>
</head>
<body>
    <h1>Capitulo 10</h1>
    <a>Ejercicio 3</a>

    <script>

        const encontrarElem = (arr, low, high, key) => {
            
            if (high < low) {
                return -1;
            }

            let mid = Math.floor((low + high) / 2);
            if (key === arr[mid]) {
                return mid;
            } 
            if (key > arr[mid]) {
                return encontrarElem(arr, (mid + 1), high, key);
            }

            return encontrarElem(arr, low, (mid - 1), key);
        }

        const incognita = (arr, low, high) => {

            if (high < low) {
                return -1;
            }
            if (high === low) {
                return low;
            }

            let mid = Math.floor((low + high) / 2);
            if (mid < high && arr[mid] > arr[mid + 1]) {
                return mid;
            } 
            if (mid > low && arr[mid] < arr[mid - 1]) {
                return (mid - 1);
            }
            if (arr[low] >= arr[mid]) {
                return incognita(arr, low, mid - 1);
            }
            return incognita(arr, mid + 1, high);
        }

        const encontrarIncognita = (arr, n, key) => {

            let incog = incognita(arr, 0, n - 1);
            if (incog === -1) {
                return encontrarElem(arr, 0, n - 1, key);
            } 
            if (arr[incog] === key) {
                return incog;
            }
            if (arr[0] <= key) {
                return encontrarElem(arr, 0, incog - 1, key);
            }
            return encontrarElem(arr, incog + 1, n - 1, key);
            
        }
 
        let arr1 = [15, 16, 19, 20, 25, 1, 3, 4, 5, 7, 10, 14];
        let n = arr1.length,
          key = 5;

        console.log(`Elemento encontrado en la matriz es: ${encontrarIncognita(arr1, n, key)}`);
 
        
        
</script>
    
</body>
</html>